#define _GNU_SOURCE
#include <stdlib.h>
#include <stdio.h>
#include <fcntl.h>
#include <sched.h>
#include <sys/wait.h>
#include <unistd.h>

#define STACK_SIZE (1L<<20)
#define FILE_FD 3

static int child(void *arg) {
	if (close(FILE_FD) == -1) {
		perror("close");
		return -1;
	}

	abort();
}

int main() {
	char *stack;

	if (open("/proc/cmdline", O_RDONLY) != FILE_FD) {
		perror("open");
		return -1;
	}


	if ((stack = malloc(STACK_SIZE)) == NULL) {
		perror("malloc");
		return -1;
	}

	if (clone(child, stack + STACK_SIZE, CLONE_VM | SIGCHLD, NULL) == -1) {
		perror("clone");
		return -1;
	}

	if (wait(0) == -1) {
		perror("wait");
		return -1;
	}

	return 0;
}
