#include <stdlib.h>
#include <netinet/in.h>
#include <stdio.h>
#include <sys/socket.h>
#include <sys/types.h>

#define PORT_NUM 13131
#define QUEUE_LENGTH 10


void syserr(char *msg) {
	perror(msg);
	exit(1);
}

int main() {
	struct sockaddr_in server_address;
	int sock;

	server_address.sin_family = AF_INET; // IPv4
	server_address.sin_addr.s_addr = htonl(INADDR_ANY); // listening on all interfaces
	server_address.sin_port = htons(PORT_NUM); // listening on port PORT_NUM

	sock = socket(AF_INET, SOCK_STREAM, 0);
	if(sock < 0)
		syserr("socket");

	// bind the socket to a concrete address
	if (bind(sock, (struct sockaddr *) &server_address, sizeof(server_address)) < 0)
		syserr("bind");

	// switch to listening (passive open)
	if (listen(sock, QUEUE_LENGTH) < 0)
		syserr("listen");

	abort();
	return 0;
}
