#!/bin/bash
set -e
export TMPDIR=${TMPDIR:=/tmp}
basedir="$(dirname $0)"

run() {
	# All executed tests will crash - suppress error messages
	( $basedir/$1 < /dev/zero > /dev/null 2>&1 || true ) 2>/dev/null

	echo -n "Test $1: "
	$basedir/verify.py core.$1 "$basedir/$2.json"
}


ulimit -c unlimited
sysctl -w kernel.core_pattern=core.%e

tmpdir="$(mktemp -d z4-tst.XXXX)"
pushd $tmpdir

make -C "$basedir"

for prog in simple clone clone2 fork single_fd dup pipe inet_socket unix_socket; do
	run $prog $prog
	run ${prog}_32 ${prog}_32
done

popd
#rm -fr $tmpdir
