#include <stdlib.h>
#include <netinet/in.h>
#include <stdio.h>
#include <sys/socket.h>
#include <sys/un.h>
#include <sys/types.h>
#include <unistd.h>

#define SOCKET_NAME "/tmp/test.socket"
#define QUEUE_LENGTH 20


void syserr(char *msg) {
	perror(msg);
	exit(1);
}

int main() {
	struct sockaddr_un sock_data;
	int sock;

	unlink(SOCKET_NAME);

	if ((sock = socket(AF_UNIX, SOCK_SEQPACKET, 0)) < 0)
		syserr("socket");

	memset(&sock_data, 0, sizeof(struct sockaddr_un));
	sock_data.sun_family = AF_UNIX;
	strncpy(sock_data.sun_path, SOCKET_NAME, sizeof(sock_data.sun_path) - 1);

	if (bind(sock, (struct sockaddr *) &sock_data, sizeof(struct sockaddr_un)) < 0)
		syserr("bind");

	if (listen(sock, QUEUE_LENGTH) < 0)
		syserr("listen");

	abort();
	return 0;
}
